import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

/**
 * @author hajo
 */
public class UsingList {

    public static void main(String[] args) {
        // createAList();
        // basicMethods();
        // initialize();
        whatWillHappen();
        // sendAsParameter();

    }


    public static void createAList() {
        // Måste ange elementtyp, *bara* referenstyper fungerar
        List<Integer> li = new ArrayList<>();   // Så eller ...
        li = new LinkedList<>(); // ...så;

        // List är typkompatibel med både ArrayList och LinkedList

    }

    public static void basicMethods() {
        List<Integer> li = new ArrayList<>();

        //System.out.println(li.get(0));  // Undantag, finns inget i listan (inga platser)

        //li.set(1, 999);     // Undantag finns inget index 1

        li.add(999);     // Ok ,lägger till sist (index 0 f.n.)
        System.out.println(li.get(0));
        System.out.println(li.size());

        li.set(0, 1000);   // Ok, index 0 finns
        System.out.println(li.get(0));
        System.out.println(li.size());

        for (int i = 0; i < 5; i++) {
            li.add(i);
        }
        System.out.println(li.size());

        li.set(3, -333);   // Ok, index 3 finns

        System.out.println(li.isEmpty());
        System.out.println(li.indexOf(1000));
        System.out.println(li.contains(1000));


    }


    public static void initialize() {
        // List<Integer> li = [1,2,3,4,5];  // Skulle vilja ha men finns *inte*!

        List<Integer> li2 = Arrays.asList(1, 2, 3);   // Snabbt och bra men...
        // li2.add(4);                             // ... kan inte lägga till, undantag!

        List<Integer> li3 = new ArrayList<>(Arrays.asList(1, 2, 3)); // Ok skapa ny lista
        li3.add(4);
        System.out.println(li3);


        li2.clear();   // Töm lista
        for (int i = 0; i < 5; i++) {   // Vanligt sätt men kräver en loop
            li2.add(i);
        }
        System.out.println(li2.size());


    }


    public static void whatWillHappen() {
        List<Integer> li = new ArrayList<>(Arrays.asList(1, 2, 3, 4, 5));

        //li.get(5);    // Fel index, undantag!

        li.remove(2);     // Hål i mitten?

        li.add(4);    // Dubletter ok?

        int i = li.indexOf(4);    // Vilken får vi?

        li.add(null);  // Vad händer?

        MyValue mv = new MyValue(1);
        List<MyValue> lmv = new ArrayList<>(Arrays.asList(new MyValue(1), new MyValue(2)));

        boolean b = lmv.contains(mv);  // Finns i lista?
        System.out.println(lmv);   // toString överskuggad

    }



    public static void sendAsParameter() {
        List<Integer> li = new ArrayList<>(); // Så eller ...
        //li = new LinkedList<>();           // ...så
        int j = doSomethingWithAList(li);  // Skicka ArrayList eller LinkedList
    }

    // Alltid List som parameter, ger oss frihet att skicka vilken lista som helst
    public static int doSomethingWithAList(List<Integer> li) {
        // Alla List har samma metoder
        return li.size();
    }


}
